## org.apache.commons.math.ode.events
Interface EventHandler

All Known Implementing Classes:
  AbstractIntegrator.EndTimeChecker, FirstOrderIntegratorWithJacobians.EventHandlerWrapper

    public interface EventHandler

This interface represents a handler for discrete events triggered during ODE integration.

Some events can be triggered at discrete times as an ODE problem is solved. This occurs for example when the integration process should be stopped as some state is reached (G-stop facility) when the precise date is unknown a priori, or when the derivatives have discontinuities, or simply when the user wants to monitor some states boundaries crossings.

These events are defined as occurring when a `g` switching function sign changes.

Since events are only problem-dependent and are triggered by the independent time variable and the state vector, they can occur at virtually any time, unknown in advance. The integrators will take care to avoid sign changes inside the steps, they will reduce the step size when such an event is detected in order to put this event exactly at the end of the current step. This guarantees that step interpolation (which always has a one step scope) is relevant even in presence of discontinuities. This is independent from the stepsize control provided by integrators that monitor the local error (this event handling feature is available for all integrators, including fixed step ones).

Since:
  1.2
Version:
  $Revision: 902214 $ $Date: 2010-01-22 13:40:28 -0500 (Fri, 22 Jan 2010) $

Field Summary
`static int` `CONTINUE` Continue indicator.
`static int` `RESET_DERIVATIVES` Reset derivatives indicator.
`static int` `RESET_STATE` Reset state indicator.
`static int` `STOP` Stop indicator.

Method Summary
`int` `eventOccurred(double t, double[] y, boolean increasing)` Handle an event and choose what to do next.
`double` `g(double t, double[] y)` Compute the value of the switching function.
`void` `resetState(double t, double[] y)` Reset the state prior to continue the integration.

Field Detail

### STOP

    static final int STOP

  Stop indicator.

  This value should be used as the return value of the `eventOccurred` method when the integration should be stopped after the event ending the current step.

  See Also:
    Constant Field Values

### RESET_STATE

    static final int RESET_STATE

  Reset state indicator.

  This value should be used as the return value of the `eventOccurred` method when the integration should go on after the event ending the current step, with a new state vector (which will be retrieved thanks to the `resetState` method).

  See Also:
    Constant Field Values

### RESET_DERIVATIVES

    static final int RESET_DERIVATIVES

  Reset derivatives indicator.

  This value should be used as the return value of the `eventOccurred` method when the integration should go on after the event ending the current step, with a new derivatives vector (which will be retrieved thanks to the `FirstOrderDifferentialEquations.computeDerivatives(double, double[], double[])` method).

  See Also:
    Constant Field Values

### CONTINUE

    static final int CONTINUE

  Continue indicator.

  This value should be used as the return value of the `eventOccurred` method when the integration should go on after the event ending the current step.

  See Also:
    Constant Field Values

Method Detail

### g

    double g(double t,
             double[] y)
             throws EventException

  Compute the value of the switching function.

  The discrete events are generated when the sign of this switching function changes. The integrator will take care to change the stepsize in such a way these events occur exactly at step boundaries. The switching function must be continuous in its roots neighborhood (but not necessarily smooth), as the integrator will need to find its roots to locate precisely the events.

  Parameters:
    `t` - current value of the independent time variable
    `y` - array containing the current value of the state vector
  Returns:
    value of the g switching function
  Throws:
    `EventException` - if the switching function cannot be evaluated

### eventOccurred

    int eventOccurred(double t,
                      double[] y,
                      boolean increasing)
                      throws EventException

  Handle an event and choose what to do next.

  This method is called when the integrator has accepted a step ending exactly on a sign change of the function, just before the step handler itself is called (see below for scheduling). It allows the user to update his internal data to acknowledge the fact the event has been handled (for example setting a flag in the `differential equations` to switch the derivatives computation in case of discontinuity), or to direct the integrator to either stop or continue integration, possibly with a reset state or derivatives.

  - if `STOP` is returned, the step handler will be called with the `isLast` flag of the `handleStep` method set to true and the integration will be stopped,
  - if `RESET_STATE` is returned, the `resetState` method will be called once the step handler has finished its task, and the integrator will also recompute the derivatives,
  - if `RESET_DERIVATIVES` is returned, the integrator will recompute the derivatives,
  - if `CONTINUE` is returned, no specific action will be taken (apart from having called this method) and integration will continue.

  The scheduling between this method and the `StepHandler` method `handleStep(interpolator, isLast)` is to call this method first and `handleStep` afterwards. This scheduling allows the integrator to pass `true` as the `isLast` parameter to the step handler to make it aware the step will be the last one if this method returns `STOP`. As the interpolator may be used to navigate back throughout the last step (as `StepNormalizer` does for example), user code called by this method and user code called by step handlers may experience apparently out of order values of the independent time variable. As an example, if the same user object implements both this `EventHandler` interface and the `FixedStepHandler` interface, a forward integration may call its `eventOccurred` method with t = 10 first and call its `handleStep` method with t = 9 afterwards. Such out of order calls are limited to the size of the integration step for `variable step handlers` and to the size of the fixed step for `fixed step handlers`.

  Parameters:
    `t` - current value of the independent time variable
    `y` - array containing the current value of the state vector
    `increasing` - if true, the value of the switching function increases when times increases around event (note that increase is measured with respect to physical time, not with respect to integration which may go backward in time)
  Returns:
    indication of what the integrator should do next, this value must be one of `STOP`, `RESET_STATE`, `RESET_DERIVATIVES` or `CONTINUE`
  Throws:
    `EventException` - if the event occurrence triggers an error

### resetState

    void resetState(double t,
                    double[] y)
                    throws EventException

  Reset the state prior to continue the integration.

  This method is called after the step handler has returned and before the next step is started, but only when `eventOccurred(double, double[], boolean)` has itself returned the `RESET_STATE` indicator. It allows the user to reset the state vector for the next step, without perturbing the step handler of the finishing step. If the `eventOccurred(double, double[], boolean)` never returns the `RESET_STATE` indicator, this function will never be called, and it is safe to leave its body empty.

  Parameters:
    `t` - current value of the independent time variable
    `y` - array containing the current value of the state vector the new state should be put in the same array
  Throws:
    `EventException` - if the state cannot be reseted

Copyright (c) 2003-2011 Apache Software Foundation